      PROGRAM S4W
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 3/27/2008
C
      CHARACTER  FOUT*40
      DIMENSION  U(17),MM1(20),MM2(20),MM3(20),MM4(20),MD(20,20,20,20)
      INTEGER    R
C
C         INITIALIZE THE MARGINAL ARRAYS.
C
      ONE = 1.0D0
      ZERO = 0.0D0
      R = 4
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS:'
      READ(*,1) FOUT
    1 FORMAT(A)
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
C
      WRITE(*,*) 'ENTER DIMENSION SIZES (N1,N2,N3,N4):'
      READ(*,*) N1,N2,N3,N4
C

      DO 4 I = 1,N1
         DO 3 J = 1,N2
            DO 2 K = 1,N3
               WRITE(*,5) 'ENTER ROW ',K,' OF LEVEL ',J,' IN BLOCK ',I
               READ(*,*) (MD(I,J,K,L),L=1,N4)
    2       CONTINUE
    3    CONTINUE
    4 CONTINUE
    5 FORMAT(T2,A,I2,A,I2,A,I2)
C
C         ACCUMULATE THE MARGINAL DISTRIBUTIONS.
C
      IT = 0
      PSTART = ZERO
      DO 15 I = 1,N1
         MM1(I) = 0
         DO 14 J = 1,N2
            DO 13 K = 1,N3
               DO 12 L = 1,N4
                  MM1(I) = MM1(I)+MD(I,J,K,L)
   12          CONTINUE
   13       CONTINUE
   14    CONTINUE
         IT = IT + MM1(I)
         PSTART = PSTART+FAC(MM1(I))
   15 CONTINUE
      DO 20 J = 1,N2
         MM2(J) = 0
         DO 19 I = 1,N1
            DO 18 K = 1,N3
               DO 17 L = 1,N4
                  MM2(J) = MM2(J)+MD(I,J,K,L)
   17          CONTINUE
   18       CONTINUE
   19    CONTINUE
         PSTART = PSTART+FAC(MM2(J))
   20 CONTINUE
      DO 25 K = 1,N3
         MM3(K) = 0
         DO 24 I = 1,N1
            DO 23 J = 1,N2
               DO 22 L = 1,N4
                  MM3(K) = MM3(K)+MD(I,J,K,L)
   22          CONTINUE
   23       CONTINUE
   24    CONTINUE
         PSTART = PSTART+FAC(MM3(K))
   25 CONTINUE
      DO 30 L = 1,N4
         MM4(L) = 0
         DO 29 I = 1,N1
            DO 28 J = 1,N2
               DO 27 K = 1,N3
                  MM4(L) = MM4(L)+MD(I,J,K,L)
   27          CONTINUE
   28       CONTINUE
   29    CONTINUE
         PSTART = PSTART+FAC(MM4(L))
   30 CONTINUE
      PSTART = PSTART-FAC(IT)*(R-1)
C
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 38 II = 1,17
         S = ZERO
         T = 0.5D0
         DO 37 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
   37    CONTINUE
         U(II) = S
   38 CONTINUE
C
      CR = RZ(IT)*(R-1)
      DO 40 I = 1,N1
         CR = CR-RZ(MM1(I))
   40 CONTINUE
      DO 45 J = 1,N2
         CR = CR-RZ(MM2(J))
   45 CONTINUE
      DO 50 K = 1,N3
         CR = CR-RZ(MM3(K))
   50 CONTINUE
      DO 55 L = 1,N4
         CR = CR-RZ(MM4(L))
   55 CONTINUE
C
C  DETERMINE THE PROBABILITY AND STATISTICS FOR OBSERVED TABLE.
C
      CELLFAC = ZERO
      CS = ZERO
      CZ = ZERO
      CL = ZERO
C
      DO 70 I = 1,N1
       DO 69 J = 1,N2
        DO 68 K = 1,N3
         DO 67 L = 1,N4
          CELLFAC = CELLFAC+FAC(MD(I,J,K,L))
          CS = CS+(ONE*MD(I,J,K,L)**2)/MM1(I)/MM2(J)/MM3(K)/MM4(L)
          CZ = CZ+(ONE*MD(I,J,K,L)*(MD(I,J,K,L)-1))
     +           /MM1(I)/MM2(J)/MM3(K)/MM4(L)
          CL = CL+RZ(MD(I,J,K,L))
   67    CONTINUE
   68   CONTINUE
   69  CONTINUE
   70 CONTINUE
C
      THISP = (PSTART-CELLFAC)*(ONE-1.0D-12)
      FEP = DEXP(THISP)
      CST = (CS*IT**(R-1)-IT)*(ONE-1.0D-12)
      IF(CST.LT.1.0D-11) CST = -1.0D-11
      CZT = (CZ*IT**(R-1)+N1*N2*N3*N4-IT)*(ONE-1.0D-12)
      IF(CZT.LT.1.0D-11) CZT = -1.0D-11
      CLT = (CL+CR)*2*(ONE-1.0D-12)
      IF(DABS(CLT).LT.1.0D-12) CLT = -1.0D-11
C
      IFE = 0
      ICS = 0
      ICZ = 0
      ICL = 0
C
      DO 110 IS = 1,MS
         CALL XCONT4(IT,N1,N2,N3,N4,CF,CS,CZ,CL,CR,U,MM1,MM2,MM3,MM4)
         CP = PSTART-CF
         IF(CP.LT.THISP) IFE = IFE+1
         IF(CS.GT.CST) ICS = ICS+1
         IF(CZ.GT.CZT) ICZ = ICZ+1
         IF(CL.GT.CLT) ICL = ICL+1
  110 CONTINUE
C
      PFE = 1.0D0*IFE/MS
      PCS = 1.0D0*ICS/MS
      PCZ = 1.0D0*ICZ/MS
      PCL = 1.0D0*ICL/MS
C
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,130) 'FOUR-WAY TABLE ANALYSES WITH SIZES ',
     +          N1,',',N2,',',N3,', &',N4
      WRITE(6,140) ISEED, ' = RANDOM NUMBER GENERATOR SEED'
      WRITE(6,140) MS, ' = NUMBER OF RANDOM TABLES GENERATED'
      WRITE(6,150) FEP, ' = PROBABILITY OF OBSERVED 4-WAY TABLE'
      WRITE(6,150) PFE, ' = SIMULATED FISHER''S EXACT TEST P-VALUE'
      IF(CST.LE.0.0D0) CST = 0.0D0
      WRITE(6,150) CST, ' = OBSERVED 4-WAY CHI-SQUARE STATISTIC T'
      WRITE(6,150) PCS, ' = SIMULATED CHI-SQUARE TEST P-VALUE'
      IF(CZT.LE.0.0D0) CZT = 0.0D0
      WRITE(6,150) CZT, ' = OBSERVED 4-WAY ZELTERMAN STATISTIC'
      WRITE(6,150) PCZ, ' = SIMULATED ZELTERMAN TEST P-VALUE'
      IF(CLT.LE.0.0D0) CLT = 0.0D0
      WRITE(6,150) CLT, ' = OBSERVED 4-WAY LIKELIHOOD-RATIO STATISTIC'
      WRITE(6,150) PCL, ' = SIMULATED LIKELIHOOD-RATIO TEST P-VALUE'
  130 FORMAT(T2,A,I2,A,I2,A,I2,A,I2)
  140 FORMAT(T5,I10,A)
  150 FORMAT(T5,G15.8,A)
      END
C
C
      SUBROUTINE XCONT4(NT,N1,N2,N3,N4,CF,CS,CZ,CL,CR,U,
     +           MM1,MM2,MM3,MM4)
      IMPLICIT REAL*8(A-H,O-Z)
C
C    GENERATES RANDOM FOUR-WAY TABLE WITH FIXED MARGINAL TOTALS
C
      DIMENSION  U(17),L1(20),L2(20),L3(20),L4(20),MC(20,20,20,20),
     +   MM1(20),MM2(20),MM3(20),MM4(20),P1(20),P2(20),P3(20),P4(20),
     +   W1(20),W2(20),W3(20),W4(20)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      LT = NT
      DO 1 I = 1,N1
         L1(I) = MM1(I)
    1 CONTINUE
      DO 2 I = 1,N2
         L2(I) = MM2(I)
    2 CONTINUE
      DO 3 I = 1,N3
         L3(I) = MM3(I)
    3 CONTINUE
      DO 4 I = 1,N4
         L4(I) = MM4(I)
    4 CONTINUE
      DO 15 I = 1,N1
         DO 14 J = 1,N2
            DO 13 K = 1,N3
               DO 12 L = 1,N4
                  MC(I,J,K,L) = 0
   12          CONTINUE
   13       CONTINUE
   14    CONTINUE
   15 CONTINUE
C
      DO 200 K = 1,NT
C
         DO 20 I = 1,N1
            P1(I) = ONE*L1(I)/LT
   20    CONTINUE
         W1(1) = P1(1)
         DO 25 I = 2,N1-1
            W1(I) = W1(I-1)+P1(I)
   25    CONTINUE
         W1(N1) = ONE
C
         DO 30 I = 1,N2
            P2(I) = ONE*L2(I)/LT
   30    CONTINUE
         W2(1) = P2(1)
         DO 35 I = 2,N2-1
            W2(I) = W2(I-1)+P2(I)
   35    CONTINUE
         W2(N2) = ONE
C
         DO 40 I = 1,N3
            P3(I) = ONE*L3(I)/LT
   40    CONTINUE
         W3(1) = P3(1)
         DO 45 I = 2,N3-1
            W3(I) = W3(I-1)+P3(I)
   45    CONTINUE
         W3(N3) = ONE
C
         DO 50 I = 1,N4
            P4(I) = ONE*L4(I)/LT
   50    CONTINUE
         W4(1) = P4(1)
         DO 55 I = 2,N4-1
            W4(I) = W4(I-1)+P4(I)
   55    CONTINUE
         W4(N4) = ONE
C
         Z = UNI(U)
         DO 80 I = 1,N1
            IF(Z.LE.W1(I)) THEN
               L1(I) = L1(I)-1
               I1 = I
               GO TO 85
            END IF
   80    CONTINUE
C
   85    Z = UNI(U)
         DO 90 I = 1,N2
            IF(Z.LE.W2(I)) THEN
               L2(I) = L2(I)-1
               I2 = I
               GO TO 95
            END IF
   90    CONTINUE
C
   95    Z = UNI(U)
         DO 100 I = 1,N3
            IF(Z.LE.W3(I)) THEN
               L3(I) = L3(I)-1
               I3 = I
               GO TO 105
            END IF
  100    CONTINUE
C
  105    Z = UNI(U)
         DO 110 I = 1,N4
            IF(Z.LE.W4(I)) THEN
               L4(I) = L4(I)-1
               I4 = I
               GO TO 115
            END IF
  110    CONTINUE
C
  115    LT = LT-1
         MC(I1,I2,I3,I4) = MC(I1,I2,I3,I4)+1
  200 CONTINUE
C
      CF = 0.0D0
      CS = 0.0D0
      CZ = 0.0D0
      CL = 0.0D0
      DO 230 I = 1,N1
        DO 225 J = 1,N2
          DO 220 K = 1,N3
            DO 215 L = 1,N4
              CF = CF+FAC(MC(I,J,K,L))
              CS = CS+(ONE*MC(I,J,K,L))**2/MM1(I)/MM2(J)/MM3(K)/MM4(L)
              CZ = CZ+ONE*MC(I,J,K,L)*(MC(I,J,K,L)-1)
     +               /MM1(I)/MM2(J)/MM3(K)/MM4(L)
              CL = CL+RZ(MC(I,J,K,L))
  215       CONTINUE
  220     CONTINUE
  225   CONTINUE
  230 CONTINUE
      CS = CS*NT**3-NT
      CZ = CZ*NT**3+N1*N2*N3*N4-NT
      CL = (CL+CR)*2
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(5000)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION RZ(I)
C  FIND I(LOG(I))
      DOUBLE PRECISION X
      X = 1.0D0*I
      IF(X.GT.1.5D0) THEN
         RZ = X*DLOG(X)
      ELSE
         RZ = 0.0D0
      ENDIF
      RETURN
      END
