      PROGRAM BINOM
C
      INTEGER  I,K,L,M,N
      REAL*8  P,H,T,P0,P1,P2,ONE,ZERO
C
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'N = # of items in sample'
      WRITE(*,*) 'K = # of marked items in sample'
      WRITE(*,*) 'P = Population proportion of marked items'
      WRITE(*,*) 'Enter N, K, P for binomial distribution'
      READ(*,*) N,K,P
      L = 0
      M = N
      IF(K.LT.L)  THEN
         P0 = ZERO
         P1 = ZERO
         P2 = ONE
         GO TO 30
      END IF
      IF(K.GT.M)  THEN
         P0 = ZERO
         P1 = ONE
         P2 = ZERO
         GO TO 30
      END IF
      H = 1.0D-100
      P0 = H
      P1 = H
      IF(K.EQ.0)  THEN
         P2 = H
         T = H
         GO TO 15
      END IF
      DO 10 I = L,K-1
         H = H*(N-I)*P/((ONE-P)*(I+1))
         P1 = P1+H
   10 CONTINUE
      P0 = H
      T = P1
      P2 = H
      IF(K.EQ.M)  GO TO 25
   15 DO 20 I = K,M-1
         H = H*(N-I)*P/((ONE-P)*(I+1))
         T = T+H
         P2 = P2+H
   20 CONTINUE
   25 P0 = P0/T
      P1 = P1/T
      P2 = P2/T
   30 WRITE(*,*) 'P(K = ',K,' | P, N)      = ',P0
      WRITE(*,*) 'P(K  ',K,' | P, N)      = ',P1
      WRITE(*,*) 'P(K  ',K,' | P, N)      = ',P2
      END
