      PROGRAM EMRPP
C
      CHARACTER  HEAD*80,FIN*40,FOUT*40
      DOUBLE PRECISION  V,DATA(30,51),RD(30,50),D(450),H,ONE,ZERO,SUM,
     +   S(10),C(10),SUP,W,Z,PL,PU,DELTAL,U(50),Y(50,50),AD(50),
     +   PHI,PSI,CL,A1,A2,A3,A4,B1,B2
      INTEGER  G,R,B(11),CFORM,KP(50),KR(50),KC(50)
C
      ND = 50
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'ENTER FILE NAME FOR INPUT DATA'
      READ(*,100) FIN
  100 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,100) FOUT
      OPEN(1,FILE=FIN)
      OPEN(2,FILE=FOUT,STATUS='NEW')
  110 READ(1,100,END=120) HEAD
      GO TO 130
  120 GO TO 2000
  130 READ(1,*) N,R,V,SUP,LZ,IR,KT,H,IC,CFORM,G
      READ(1,*) (B(I),I = 1,G)
      DO 160 I = 1,N
         READ(1,*,END=170) (DATA(I,J),J = 1,R)
  160 CONTINUE
      GO TO 180
  170 WRITE(*,175) 'ERROR:  END OF FILE ENCOUNTERED'
  175 FORMAT(/,T3,A)
      STOP
  180 KZ = 0
      DO 200 I = 1,G
         KZ = KZ+B(I)
  200 CONTINUE
      IF(KZ.GT.N) STOP 'SUM OF GROUP SIZES EXCEEDS TOTAL CASES'
      IF(R.EQ.1) LZ = 0
      IF(R.EQ.1) IC = 0
      IF(IR.NE.1) GO TO 300
      DO 270 J = 1,R
         CL = 1.0D30
         DO 210 I = 1,N
            IF(DATA(I,J).LT.CL) CL = DATA(I,J)
  210    CONTINUE
         DO 220 I = 1,N
            DATA(I,J) = DATA(I,J)-CL+1
  220    CONTINUE
         PHI = ONE+1.0D-12
         A1 = ZERO
         A2 = ZERO
         A3 = ONE*N-0.1D0
         B1 = ZERO-1.0D30
         B2 = 1.0D30
  230    IF(A2.GT.A3) GO TO 270
         DO 240 I = 1,N
            IF(DATA(I,J).GT.B1.AND.DATA(I,J).LT.B2) B2 = DATA(I,J)*PHI
  240    CONTINUE
         DO 250 I = 1,N
            PSI = DABS(ONE-DATA(I,J)/B2)
            IF(PSI.LT.1.0D-11) A1 = A1+1
  250    CONTINUE
         A4 = A2+(A1+1)/2
         DO 260 I = 1,N
            PSI = DABS(ONE-DATA(I,J)/B2)
            IF(PSI.LT.1.0D-11) RD(I,J) = A4
  260    CONTINUE
         A2 = A2+A1
         A1 = ZERO
         B1 = B2
         B2 = 1.0D30
         GO TO 230
  270 CONTINUE
      Z = ONE*(N+1)/2
      DO 290 I = 1,N
         DO 280 J = 1,R
            GO TO (272,274,276) KT
  272       DATA(I,J) = RD(I,J)**H
            GO TO 280
  274       DATA(I,J) = ZERO
            W = DABS(Z-RD(I,J))
            IF(W.LT.1.0D-11) GO TO 280
            DATA(I,J) = DABS(RD(I,J)-Z)**H
            GO TO 280
  276       DATA(I,J) = ZERO
            W = DABS(Z-RD(I,J))
            IF(W.LT.1.0D-11) GO TO 280
            IF(RD(I,J).GT.Z) THEN
               DATA(I,J) = (RD(I,J)-Z)**H
            ELSEIF(RD(I,J).LT.Z) THEN
               DATA(I,J) = ZERO-(Z-RD(I,J))**H
            ENDIF
  280    CONTINUE
  290 CONTINUE
  300 WRITE(2,100) HEAD
      IF(LZ.EQ.1) THEN
        HEAD = 'EXACT MULTIVARIATE HOTELLING-TYPE PERMUTATION RESULTS'
        GO TO 329
      ELSE
        HEAD = 'EXACT MULTI-RESPONSE PERMUTATION PROCEDURE RESULTS'
      END IF
      IF(IR.EQ.1.OR.IC.NE.1) GO TO 329
      DO 323 I = 1,R
         AD(I) = ZERO
         DO 322 J = 1,N-1
            DO 321 K = J+1,N
               AD(I) = AD(I)+(DABS(DATA(J,I)-DATA(K,I)))**V
  321       CONTINUE
  322    CONTINUE
         AD(I) = AD(I)**(ONE/V)
  323 CONTINUE
      DO 327 I = 1,N
         DO 326 J = 1,R
            DATA(I,J) = DATA(I,J)/AD(J)
  326    CONTINUE
  327 CONTINUE
  329 WRITE(2,330) HEAD
  330 FORMAT(T15,A,/)
      WRITE(2,340) N,R,V,G,SUP
  340 FORMAT(T5,'NUMBER OF OBJECTS =',I3,/,T5,'NUMBER OF RESPONSES =',
     +   I3,/,T5,'DISTANCE EXPONENT =',G15.8,/,T5,'NUMBER OF GROUPS =',
     +   I3,/,T5,'UPPER DISTANCE BOUND =',G15.8)
      GO TO (341,342,343,344) CFORM
  341 WRITE(2,346) 'C(I) = n(I)/sum(n(I))'
      GO TO 348
  342 WRITE(2,346) 'C(I) = (n(I)-1)/sum(n(I)-1)'
      GO TO 348
  343 WRITE(2,346) 'C(I) = 1/sum(1)'
      GO TO 348
  344 WRITE(2,346) 'C(I) = n(I)*(n(I)-1)/sum(n(I)*(n(I)-1))'
  346 FORMAT(T5,A,/)
  348 K = 0
      DO 350 I = 1,G
         WRITE(2,360) I,B(I)
         K = K+B(I)
  350 CONTINUE
  360 FORMAT(T5,'SIZE OF GROUP ',I2,' =',I3)
      B(G+1) = N-K
      DO 370 I = 1,G
         S(I) = ONE*B(I)*(B(I)-1)/2
  370 CONTINUE
      WRITE(2,380) B(G+1)
  380 FORMAT(T5,'SIZE OF EXCESS GROUP =',I3,/)
      GO TO (410,430,450,470) CFORM
  410 DO 420 I = 1,G
         C(I) = ONE*B(I)/K
  420 CONTINUE
      GO TO 500
  430 DO 440 I = 1,G
         C(I) = ONE*(B(I)-1)/(K-G)
  440 CONTINUE
      GO TO 500
  450 DO 460 I = 1,G
         C(I) = ONE/G
  460 CONTINUE
      GO TO 500
  470 W = ZERO
      DO 475 I = 1,G
         W = W+ONE*B(I)*(B(I)-1)
  475 CONTINUE
      DO 480 I = 1,G
         C(I) = ONE*B(I)*(B(I)-1)/W
  480 CONTINUE
  500 L = 1
      IF(LZ.NE.1) GO TO 565
      DO 510 I = 1,R
         U(I) = ZERO
         DO 505 J = 1,N
            U(I) = U(I)+DATA(J,I)
  505    CONTINUE
         U(I) = U(I)/N
  510 CONTINUE
      DO 525 I = 1,R
         DO 520 J = I,R
            Y(I,J) = ZERO
            DO 515 K = 1,N
               Y(I,J) = Y(I,J)+(DATA(K,I)-U(I))*(DATA(K,J)-U(J))
  515       CONTINUE
            Y(J,I) = Y(I,J)
  520    CONTINUE
  525 CONTINUE
      CALL INVERT(R,Y,KP,KR,KC,ND)
      DO 545 I = 1,N-1
         DO 540 J = I+1,N
            SUM = ZERO
            DO 535 K1 = 1,R
               DO 530 K2 = 1,R
                  SUM = SUM+(DATA(I,K1)-DATA(J,K1))*Y(K1,K2)*
     1                      (DATA(I,K2)-DATA(J,K2))
  530          CONTINUE
  535       CONTINUE
            D(L) = SUM**(V/2)
            IF(D(L).GT.SUP) D(L) = SUP
            L = L+1
  540    CONTINUE
  545 CONTINUE
      GO TO 585
  565 DO 580 I = 1,N-1
         DO 575 J = I+1,N
            SUM = ZERO
            DO 570 K = 1,R
               SUM = SUM+(DATA(I,K)-DATA(J,K))**2
  570       CONTINUE
            D(L) = SUM**(V/2)
            IF(D(L).GT.SUP) D(L) = SUP
            L = L+1
  575    CONTINUE
  580 CONTINUE
  585 CALL PERM(N,G,B,S,C,D,KOUNT1,KOUNT2,KOUNT3,DELTAL)
      PL = ONE*KOUNT2/KOUNT1
      PU = ONE*KOUNT3/KOUNT1
      IF(IR.EQ.1) THEN
         GO TO (586,588,590) KT
  586    HEAD = 'MRPP VERSION OF A(N,H) RANKS TEST'
         WRITE(2,591) HEAD
         WRITE(2,592) 'A(N,H) RANKS TEST EXPONENT H = ',H
         GO TO 593
  588    HEAD = 'MRPP VERSION OF B(N,H) RANKS TEST'
         WRITE(2,591) HEAD
         WRITE(2,592) 'B(N,H) RANKS TEST EXPONENT H = ',H
         GO TO 593
  590    HEAD = 'MRPP VERSION OF C(N,H) RANKS TEST'
         WRITE(2,591) HEAD
         WRITE(2,592) 'C(N,H) RANKS TEST EXPONENT H = ',H
      END IF
  591 FORMAT(T5,A)
  592 FORMAT(T5,A,G15.8)
  593 IF(LZ.EQ.0) WRITE(2,594) IC
  594 FORMAT(T5,'1 (0) IMPLIES (NO) AVE. D.F. COMMENSURATION:',I3)
      WRITE(2,595) DELTAL
  595 FORMAT(T5,'OBSERVED MRPP STATISTIC (d0) =',G15.8)
      WRITE(2,600) KOUNT1
  600 FORMAT(T5,'TOTAL NUMBER OF d VALUES =',I9)
      WRITE(2,605) KOUNT2
  605 FORMAT(T5,'NUMBER OF d VALUES < or = to d0 =',I9)
      WRITE(2,610) KOUNT3
  610 FORMAT(T5,'NUMBER OF d VALUES > or = to d0 =',I9)
      WRITE(2,800) PL
  800 FORMAT(T5,'EXACT LOWER-TAIL MRPP P-VALUE =',G15.8)
      WRITE(2,805) PU
  805 FORMAT(T5,'EXACT UPPER-TAIL MRPP P-VALUE =',G15.8)
      WRITE(2,900)
  900 FORMAT('********************************************************')
      GO TO 110
 2000 CLOSE(1)
      CLOSE(2)
      END
C
C
      SUBROUTINE INVERT(N,W,KP,KR,KC,ND)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION  KP(N),KR(N),KC(N),W(ND,N)
C
      ZERO = 0.0D0
      DO 5 I = 1,N
         KP(I) = 0
    5 CONTINUE
      DO 45 I = 1,N
         T = ZERO
         DO 20 J = 1,N
            IF(KP(J).NE.1) THEN
               DO 15 K = 1,N
                  IF(KP(K)-1) 10,15,60
   10             IF(T.LT.DABS(W(J,K))) THEN
                     IR = J
                     IC = K
                     T = DABS(W(J,K))
                  END IF
   15          CONTINUE
            END IF
   20    CONTINUE
         KP(IC) = KP(IC)+1
         IF(IR.NE.IC) THEN
            DO 25 L = 1,N
               T = W(IR,L)
               W(IR,L) = W(IC,L)
               W(IC,L) = T
   25       CONTINUE
         END IF
         KR(I) = IR
         KC(I) = IC
         T = W(IC,IC)
         W(IC,IC) = 1.0D0
         DO 30 L = 1,N
            W(IC,L) = W(IC,L)/T
   30    CONTINUE
         DO 40 M = 1,N
            IF(M.NE.IC) THEN
               T = W(M,IC)
               W(M,IC) = ZERO
               DO 35 L = 1,N
                  W(M,L) = W(M,L)-W(IC,L)*T
   35          CONTINUE
            END IF
   40    CONTINUE
   45 CONTINUE
      DO 55 I = 1,N
         J = N-I+1
         IF(KR(J).NE.KC(J)) THEN
            K = KR(J)
            L = KC(J)
            DO 50 M = 1,N
               T = W(M,K)
               W(M,K) = W(M,L)
               W(M,L) = T
   50       CONTINUE
         END IF
   55 CONTINUE
   60 RETURN
      END
C
C
      SUBROUTINE PERM(N,G,B,S,C,D,KOUNT1,KOUNT2,KOUNT3,DELTAL)
C
      DOUBLE PRECISION  D(450),S(10),C(10),DELTAL,DELTAU
      INTEGER  G,A(11,30),B(11),P(30)
C
      K = G
      IF(B(G+1).NE.0) K = K+1
      L = N
      DO 50 I = 1,K-1
         DO 30 J = 1,B(I)
            A(I,J) = I
   30    CONTINUE
         DO 40 J = B(I)+1,L
            A(I,J) = I+1
   40    CONTINUE
         L = L-B(I)
   50 CONTINUE
      KOUNT1 = 0
      KOUNT2 = 0
      KOUNT3 = 0
   60 I = K-1
      NMARKS = B(K)+B(I)
      IF(KOUNT1.EQ.0) GO TO 130
   70 DO 80 J = 1,NMARKS-1
         IF(A(I,J).EQ.I.AND.A(I,J+1).EQ.I+1) THEN
            LIMIT = J-2
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)-1
            IF(LIMIT.LE.0) GO TO 130
            GO TO 110
         END IF
   80 CONTINUE
      IF(NMARKS.EQ.1) GO TO 100
      DO 90 J = 1,NMARKS/2
         ITEMP = A(I,J)
         A(I,J) = A(I,NMARKS-J+1)
         A(I,NMARKS-J+1) = ITEMP
   90 CONTINUE
  100 I = I-1
      IF(I.EQ.0) RETURN
      NMARKS = NMARKS+B(I)
      GO TO 70
  110 IFLAG = 0
      DO 120 J = 1,LIMIT
         IF(A(I,J).EQ.I+1.AND.A(I,J+1).EQ.I) THEN
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)+1
            IFLAG = 1
         END IF
  120 CONTINUE
      IF(IFLAG.EQ.1) GO TO 110
  130 DO 140 J = 1,N
         A(K,J) = A(1,J)
  140 CONTINUE
      IF(K.EQ.2) GO TO 170
      DO 160 L = 2,K-1
         M = 1
         DO 150 J = 1,N
            IF(A(K,J).EQ.L) THEN
               A(K,J) = A(L,M)
               M = M+1
            END IF
  150    CONTINUE
  160 CONTINUE
  170 LL = 1
      DO 190 II = 1,K
         DO 180 JJ = 1,N
            IF(A(K,JJ).EQ.II) THEN
               P(LL) = JJ
               LL = LL+1
            END IF
  180    CONTINUE
  190 CONTINUE
      CALL DVAL(N,G,B,S,C,D,P,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU)
      KOUNT1 = KOUNT1+1
      GO TO 60
      END
C
C
      SUBROUTINE DVAL(N,G,B,S,C,D,P,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU)
C
      DOUBLE PRECISION  D(450),S(10),C(10),ZERO,ONE,XI(10),DELTA,DELTAL,
     +   DELTAU,PREC
      INTEGER  G,B(11),P(30)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      PREC = 1.0D-12
      LL = 0
      DO 30 II = 1,G
         KK = LL+1
         LL = LL+B(II)
         XI(II) = ZERO
         DO 20 III = KK,LL-1
            I = P(III)
            DO 10 JJJ = III+1,LL
               J = P(JJJ)
               K = N*(I-1)+J-(I*(I+1))/2
               XI(II) = XI(II)+D(K)
   10       CONTINUE
   20    CONTINUE
         XI(II) = XI(II)/S(II)
   30 CONTINUE
      DELTA = ZERO
      DO 40 II = 1,G
         DELTA = DELTA+C(II)*XI(II)
   40 CONTINUE
      IF(KOUNT1.EQ.0) THEN
         DELTAL = DELTA*(ONE+PREC)
         DELTAU = DELTA*(ONE-PREC)
      END IF
      IF(DELTA.LT.DELTAL) KOUNT2 = KOUNT2+1
      IF(DELTA.GT.DELTAU) KOUNT3 = KOUNT3+1
      RETURN
      END
