      PROGRAM EMRSP
C
      CHARACTER  HEAD*80,FIN*40,FOUT*40
      DOUBLE PRECISION  V,ONE,ZERO,TWO,PREC,C,DELTA,DELTAL,DELTAU,PL,PU,
     +                  AD(50),S(14),DATA(15,50)
      INTEGER  R
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      PREC = 1.0D-12
      WRITE(*,*) 'ENTER FILE NAME FOR INPUT DATA'
      READ(*,100) FIN
  100 FORMAT(A)
      WRITE(*,*) 'ENTER FILE NAME FOR OUTPUT RESULTS'
      READ(*,100) FOUT
      OPEN(1,FILE=FIN)
      OPEN(2,FILE=FOUT,STATUS='NEW')
  110 READ(1,100,END=120) HEAD
      GO TO 130
  120 GO TO 2000
  130 READ(1,*) N,R,V,IC
      DO 160 I = 1,N
         READ(1,*,END=170) (DATA(I,J),J = 1,R)
  160 CONTINUE
      GO TO 200
  170 WRITE(*,175) 'ERROR:  END OF FILE ENCOUNTERED'
  175 FORMAT(/,T3,A)
      STOP
  200 IF(R.EQ.1) IC = 0
      WRITE(2,100) HEAD
      HEAD = 'EXACT MULTI-RESPONSE SEQUENTIAL PROCEDURE RESULTS'
      IF(R.EQ.1.OR.IC.NE.1) GO TO 329
      DO 323 I = 1,R
         AD(I) = ZERO
         DO 322 J = 1,N-1
            DO 321 K = J+1,N
               AD(I) = AD(I)+(DABS(DATA(J,I)-DATA(K,I)))**V
  321       CONTINUE
  322    CONTINUE
         AD(I) = AD(I)**(ONE/V)
  323 CONTINUE
      DO 327 I = 1,N
         DO 326 J = 1,R
            DATA(I,J) = DATA(I,J)/AD(J)
  326    CONTINUE
  327 CONTINUE
  329 WRITE(2,330) HEAD
  330 FORMAT(T15,A,/)
      WRITE(2,340) N,R,V
  340 FORMAT(T5,'NUMBER OF OBJECTS =',I3,/,T5,'NUMBER OF RESPONSES =',
     +   I3,/,T5,'DISTANCE EXPONENT =',G15.8)
      DELTA = ZERO
      C = ONE*(N-1)
      DO 580 I = 1,N-1
         S(I) = ZERO
         DO 570 K = 1,R
            S(I) = S(I)+(DATA(I,K)-DATA(I+1,K))**2
  570    CONTINUE
         DELTA = DELTA+S(I)**(V/TWO)
  580 CONTINUE
      DELTAL = DELTA*(ONE+PREC)/C
      DELTAU = DELTA*(ONE-PREC)/C
      CALL FACT(N,R,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU,C,V,DATA)
      PL = ONE*KOUNT2/KOUNT1
      PU = ONE*KOUNT3/KOUNT1
      WRITE(2,590) IC
  590 FORMAT(T5,'1 (0) IMPLIES (NO) AVE. D.F. COMMENSURATION:',I3)
      WRITE(2,595) DELTAL
  595 FORMAT(T5,'OBSERVED MRSP STATISTIC =',G15.8)
      WRITE(2,600) KOUNT1
  600 FORMAT(T5,'N FACTORIAL =',I9)
      WRITE(2,605) PL
  605 FORMAT(T5,'EXACT LOWER TAIL MRSP P-VALUE =',G15.8)
      WRITE(2,610) PU
  610 FORMAT(T5,'EXACT UPPER TAIL MRSP P-VALUE =',G15.8)
      WRITE(2,700)
  700 FORMAT('********************************************************')
      GO TO 110
 2000 CLOSE(1)
      CLOSE(2)
      END
C
C
      SUBROUTINE FACT(N,R,KOUNT1,KOUNT2,KOUNT3,DELTAL,DELTAU,C,V,DATA)
C
      DOUBLE PRECISION  DELTAL,DELTAU,C,V,DATA(15,50)
      INTEGER  R,P(15),A(15,15)
C
      K = N
      L = N
      DO 50 I = 1,K-1
         A(I,1) = I
         DO 40 J = 2,L
            A(I,J) = I+1
   40    CONTINUE
         L = L-1
   50 CONTINUE
      KOUNT1 = 0
      KOUNT2 = 0
      KOUNT3 = 0
   60 I = K-1
      NMARKS = 2
      IF(KOUNT1.EQ.0) GO TO 130
   70 DO 80 J = 1,NMARKS-1
         IF(A(I,J).EQ.I.AND.A(I,J+1).EQ.I+1) THEN
            LIMIT = J-2
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)-1
            IF(LIMIT.LE.0) GO TO 130
            GO TO 110
         END IF
   80 CONTINUE
      IF(NMARKS.EQ.1) GO TO 100
      DO 90 J = 1,NMARKS/2
         ITEMP = A(I,J)
         A(I,J) = A(I,NMARKS-J+1)
         A(I,NMARKS-J+1) = ITEMP
   90 CONTINUE
  100 I = I-1
      IF(I.EQ.0) RETURN
      NMARKS = NMARKS+1
      GO TO 70
  110 IFLAG = 0
      DO 120 J = 1,LIMIT
         IF(A(I,J).EQ.I+1.AND.A(I,J+1).EQ.I) THEN
            A(I,J) = A(I,J+1)
            A(I,J+1) = A(I,J)+1
            IFLAG = 1
         END IF
  120 CONTINUE
      IF(IFLAG.EQ.1) GO TO 110
  130 DO 140 J = 1,N
         A(K,J) = A(1,J)
  140 CONTINUE
      IF(K.EQ.2) GO TO 170
      DO 160 L = 2,K-1
         M = 1
         DO 150 J = 1,N
            IF(A(K,J).EQ.L) THEN
               A(K,J) = A(L,M)
               M = M+1
            END IF
  150    CONTINUE
  160 CONTINUE
  170 LL = 1
      DO 190 II = 1,K
         DO 180 JJ = 1,N
            IF(A(K,JJ).EQ.II) THEN
               P(LL) = JJ
               LL = LL+1
            END IF
  180    CONTINUE
  190 CONTINUE
      CALL DVAL(N,R,KOUNT2,KOUNT3,DELTAL,DELTAU,C,V,P,DATA)
      KOUNT1 = KOUNT1+1
      GO TO 60
      END
C
C
      SUBROUTINE DVAL(N,R,KOUNT2,KOUNT3,DELTAL,DELTAU,C,V,P,DATA)
C
      DOUBLE PRECISION  ZERO,ONE,TWO,DELTA,DELTAL,DELTAU,C,V,
     +                  S(14),DATA(15,50),X(15,50)
      INTEGER  R,P(15)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      TWO = 2.0D0
      DO 200 I = 1,N
         DO 100 J = 1,R
            X(I,J) = DATA(P(I),J)
  100    CONTINUE
  200 CONTINUE
      DELTA = ZERO
      DO 400 I = 1,N-1
         S(I) = ZERO
         DO 300 K = 1,R
            S(I) = S(I)+(X(I,K)-X(I+1,K))**2
  300    CONTINUE
         DELTA = DELTA+S(I)**(V/TWO)
  400 CONTINUE
      DELTA = DELTA/C
      IF(DELTA.LT.DELTAL) KOUNT2 = KOUNT2+1
      IF(DELTA.GT.DELTAU) KOUNT3 = KOUNT3+1
      RETURN
      END
