      PROGRAM RKAP3
      IMPLICIT REAL*8(A-H,O-Z)
C
C        PROGRAM MODIFIED 3/25/2008
C
      CHARACTER  FIN*40,FOUT*40
      DIMENSION  U(17),MM1(20),MM2(20),MM3(20),W(20,20,20),L(20,20,20)
C
      ONE = 1.0D0
      ZERO = 0.0D0
      WRITE(*,*) 'ENTER: FILE NAME OF INPUT DATA'
      READ(*,1) FIN
    1 FORMAT(A)
      WRITE(*,*) 'ENTER: FILE NAME FOR OUTPUT RESULTS'
      READ(*,1) FOUT
      WRITE(*,*) 'ENTER RANDOM # SEED & # OF SIMULATIONS:'
      READ(*,*) ISEED,MS
      OPEN(3,FILE=FIN)
      READ(3,*) N1
      N2 = N1
      N3 = N1
      DO 4 I = 1,N1
       DO 3 J = 1,N2
        DO 2 K = 1,N3
         READ(3,*) W(I,J,K),L(I,J,K)
    2   CONTINUE
    3  CONTINUE
    4 CONTINUE
      CLOSE(3)
C
      K = 24
      I1 = MOD(IABS(ISEED),177)+1
      J1 = MOD(IABS(ISEED),167)+1
      K1 = MOD(IABS(ISEED),157)+1
      L1 = MOD(IABS(ISEED),147)+1
      DO 8 II = 1,17
         S = 0.0D0
         T = 0.5D0
         DO 7 JJ = 1,K
            M1 = MOD(MOD(I1*J1,179)*K1,179)
            I1 = J1
            J1 = K1
            K1 = M1
            L1 = MOD(53*L1+1,169)
            IF(MOD(L1*M1,64).GE.32) S = S+T
            T = T/2
    7    CONTINUE
         U(II) = S
    8 CONTINUE
C
      IT = 0
      PSTART = 0.0D0
      DO 12 I = 1,N1
         MM1(I) = 0
         DO 11 J = 1,N2
            DO 10 K = 1,N3
               MM1(I) = MM1(I)+L(I,J,K)
   10       CONTINUE
   11    CONTINUE
         IT = IT+MM1(I)
         PSTART = PSTART+FAC(MM1(I))
   12 CONTINUE
      DO 15 J = 1,N2
         MM2(J) = 0
         DO 14 I = 1,N1
            DO 13 K = 1,N3
               MM2(J) = MM2(J)+L(I,J,K)
   13       CONTINUE
   14    CONTINUE
         PSTART = PSTART+FAC(MM2(J))
   15 CONTINUE
      DO 18 K = 1,N3
         MM3(K) = 0
         DO 17 I = 1,N1
            DO 16 J = 1,N2
               MM3(K) = MM3(K)+L(I,J,K)
   16       CONTINUE
   17    CONTINUE
         PSTART = PSTART+FAC(MM3(K))
   18 CONTINUE
      PSTART = PSTART-FAC(IT)*2
C
      CELLFAC = 0.0D0
      ZO = 0.0D0
      ZE = 0.0D0
      DO 27 I = 1,N1
         DO 26 J = 1,N2
            DO 25 K = 1,N3
               CELLFAC = CELLFAC+FAC(L(I,J,K))
               ZO = ZO+W(I,J,K)*L(I,J,K)
               ZE = ZE+W(I,J,K)*MM1(I)*MM2(J)*MM3(K)
   25       CONTINUE
   26    CONTINUE
   27 CONTINUE
      FEP = DEXP(PSTART-CELLFAC)
      ZOT = 1.0D0-ZO*IT*IT/ZE
      IF(ZOT.GT.0.0D0) THEN
         ZOL = ZOT*(1.0D0+1.0D-10)
         ZOU = ZOT*(1.0D0-1.0D-10)
         GO TO 30
      END IF
      IF(ZOT.LT.0.0D0) THEN
         ZOL = ZOT*(1.0D0-1.0D-10)
         ZOU = ZOT*(1.0D0+1.0D-10)
         GO TO 30
      END IF
      IF(ZOT.EQ.0.0D0) THEN
         ZOL = 1.0D-11
         ZOU = -1.0D-11
         GO TO 30
      END IF
C
   30 ZO2 = DABS(ZOT)-1.0D-11
      IZL = 0
      IZU = 0
      IZ2 = 0
      W2 = 0.0D0
      W3 = 0.0D0
C
      DO 45 IS = 1,MS
         CALL XCONT3(IT,N1,N2,N3,X,ZE,U,MM1,MM2,MM3,W)
         IF(X.LT.ZOL) IZL = IZL+1
         IF(X.GT.ZOU) IZU = IZU+1
         IF(DABS(X).GT.ZO2) IZ2 = IZ2+1
         W2 = W2+X**2
         W3 = W3+X**3
   45 CONTINUE
C
      PZL = 1.0D0*IZL/MS
      PZU = 1.0D0*IZU/MS
      PZ2 = 1.0D0*IZ2/MS
      EW = 0.0D0
      W2 = W2/MS
      W3 = (W3/MS)/(DSQRT(W2))**3
C
      OPEN(6,FILE=FOUT,STATUS='NEW')
      WRITE(6,48) 'THREE-WAY CONTINGENCY TABLE ANALYSES OF SIZE ',
     +          N1,',',N2,',',N3,' FOR ARRAYS 1, 2, & 3'
      WRITE(6,49) ISEED, ' = RANDOM NUMBER GENERATOR SEED'
      WRITE(6,49) MS, ' = NUMBER OF RANDOM TABLES GENERATED'
      WRITE(6,50) FEP, ' = PROBABILITY OF OBSERVED 3-WAY TABLE'
      WRITE(6,50) ZOT, ' = OBSERVED 3-WAY KAPPA TEST STATISTIC'
      WRITE(6,50) EW, ' = EXPECTED 3-WAY KAPPA TEST STATISTIC'
      WRITE(6,50) W2, ' = SAMPLE 3-WAY KAPPA TEST STATISTIC VARIANCE'
      WRITE(6,50) W3, ' = SAMPLE 3-WAY KAPPA TEST STATISTIC SKEWNESS'
      WRITE(6,50) PZL, ' = SIMULATED 3-WAY KAPPA LOWER TAIL P-VALUE'
      WRITE(6,50) PZU, ' = SIMULATED 3-WAY KAPPA UPPER TAIL P-VALUE'
      WRITE(6,50) PZ2, ' = SIMULATED 3-WAY KAPPA TWO-SIDED P-VALUE'
   48 FORMAT(T2,A,I2,A,I2,A,I2,A,/)
   49 FORMAT(T5,I10,A)
   50 FORMAT(T5,G15.8,A)
      CLOSE(6)
      END
C
C
      SUBROUTINE XCONT3(NT,N1,N2,N3,X,ZE,U,MM1,MM2,MM3,W)
      IMPLICIT REAL*8(A-H,O-Z)
C
C    GENERATES RANDOM THREE-WAY TABLE WITH FIXED MARGINAL TOTALS
C
      DIMENSION  U(17),L1(20),L2(20),L3(20),MM1(20),MM2(20),MM3(20),
     +           P1(20),P2(20),P3(20),W1(20),W2(20),W3(20),MC(20,20,20),
     +           W(20,20,20)
C
      ZERO = 0.0D0
      ONE = 1.0D0
      LT = NT
      DO 1 I = 1,N1
         L1(I) = MM1(I)
    1 CONTINUE
      DO 2 I = 1,N2
         L2(I) = MM2(I)
    2 CONTINUE
      DO 3 I = 1,N3
         L3(I) = MM3(I)
    3 CONTINUE
      DO 9 I = 1,N1
         DO 8 J = 1,N2
            DO 7 K = 1,N3
               MC(I,J,K) = 0
    7       CONTINUE
    8    CONTINUE
    9 CONTINUE
C
      DO 100 K = 1,NT
C
         DO 20 I = 1,N1
            P1(I) = ONE*L1(I)/LT
   20    CONTINUE
         W1(1) = P1(1)
         DO 25 I = 2,N1-1
            W1(I) = W1(I-1)+P1(I)
   25    CONTINUE
         W1(N1) = ONE
C
         DO 30 I = 1,N2
            P2(I) = ONE*L2(I)/LT
   30    CONTINUE
         W2(1) = P2(1)
         DO 35 I = 2,N2-1
            W2(I) = W2(I-1)+P2(I)
   35    CONTINUE
         W2(N2) = ONE
C
         DO 40 I = 1,N3
            P3(I) = ONE*L3(I)/LT
   40    CONTINUE
         W3(1) = P3(1)
         DO 45 I = 2,N3-1
            W3(I) = W3(I-1)+P3(I)
   45    CONTINUE
         W3(N3) = ONE
C
         Z = UNI(U)
         DO 50 I = 1,N1
            IF(Z.LE.W1(I)) THEN
               L1(I) = L1(I)-1
               I1 = I
               GO TO 55
            END IF
   50    CONTINUE
C
   55    Z = UNI(U)
         DO 60 I = 1,N2
            IF(Z.LE.W2(I)) THEN
               L2(I) = L2(I)-1
               I2 = I
               GO TO 65
            END IF
   60    CONTINUE
C
   65    Z = UNI(U)
         DO 70 I = 1,N3
            IF(Z.LE.W3(I)) THEN
               L3(I) = L3(I)-1
               I3 = I
               GO TO 75
            END IF
   70    CONTINUE
C
   75    LT = LT-1
         MC(I1,I2,I3) = MC(I1,I2,I3)+1
  100 CONTINUE
C
      X = ZERO
      DO 220 I = 1,N1
        DO 219 J = 1,N2
          DO 218 K = 1,N3
            X = X+W(I,J,K)*MC(I,J,K)
  218     CONTINUE
  219   CONTINUE
  220 CONTINUE
      X = ONE-X*NT*NT/ZE
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION UNI(U)
      IMPLICIT REAL*8(A-H,O-Z)
C
      DIMENSION U(17)
      PARAMETER(CSAVE = 2.1602869033813D-2, CD = 0.45623308420181D0,
     +    CM = 0.99999982118607D0)
      SAVE I,J,C
      DATA I,J,C/17,5,CSAVE/
C
      UNI = U(I)-U(J)
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      U(I) = UNI
      I = I-1
      IF(I.EQ.0) I = 17
      J = J-1
      IF(J.EQ.0) J = 17
      C = C-CD
      IF(C.LT.0.0D0) C = C+CM
      UNI = UNI-C
      IF(UNI.LT.0.0D0) UNI = UNI+1.0D0
      RETURN
      END
C  ...........................................................................
      DOUBLE PRECISION FUNCTION FAC(I)
C  FIND LOG(I!)
      DOUBLE PRECISION  W,PREV(5000)
      INTEGER  I,J,MAX
      DATA  MAX/1/
C  INITIALIZE LOG(0!) = LOG(1) = 0
      FAC = 0.0D0
      PREV(1) = 0.0D0
      IF(I.LE.1) RETURN
C  CHECK TO SEE IF CALCULATION HAS ALREADY BEEN DONE.
      IF(I.LE.MAX) THEN
         FAC = PREV(I)
         RETURN
      ENDIF
      FAC = PREV(MAX)
      DO 10 J = MAX+1,I
         W = 1.0D0*J
         FAC = FAC+DLOG(W)
         PREV(J) = FAC
   10 CONTINUE
      MAX = I
      RETURN
      END
