      PROGRAM FCPV
C
C  THE PRESENT MAXIMUM VALUE OF M FOR FISHER'S COMBINED P-VALUE FOR M
C  INDEPENDENT P-VALUES IS M = 50.
C
      DOUBLE PRECISION T,ZERO,ONE,Q(50),P,A,B
C
      ZERO = 0.0D0
      ONE = 1.0D0
      WRITE(*,*) 'FISHER COMBINED P-VALUE FOR M INDEPENDENT P-VALUES'
      WRITE(*,*) 'ENTER M,P(1),...,P(M)'
      READ(*,*) M,(Q(I),I=1,M)
      T = ZERO
      DO 5 I = 1,M
         T = T-DLOG(Q(I))*2
    5 CONTINUE
      N = 2*M
      P = DEXP(-T/2)
      IF(N.LT.3) GO TO 20
      K = (N-2)/2
      B = ONE
      DO 15 J = 1,K
         L = J
         A = ONE
         DO 10 I = 1,L
            A = A*T/(2*I)
   10    CONTINUE
         B = B+A
   15 CONTINUE
      P = P*B
   20 WRITE(*,25) T, ' = OBSERVED CHI-SQUARE STATISTIC T'
   25 FORMAT(T5,G16.8,A)
      WRITE(*,30) N, ' = DEGREES OF FREEDOM N'
   30 FORMAT(T16,I5,A)
      WRITE(*,25) P, ' = P-VALUE OF T'
      END
